//=================================================
//	 Steampunk Nixie Tube Clock 1.0
//	 Written by: Dean Beedell
//
//	 Dean.beedell@lightquick.co.uk
//	 Copyright (C) 2011 All Rights Reserved.
//=================================================

/*global clockTimer,
		 leftHourIndicator, rightHourIndicator,
		 leftMinuteIndicator, rightMinuteIndicator,
		 leftSecondIndicator, rightSecondIndicator
*/

/*properties getHours, getMinutes, getSeconds, hour24Pref, interval,
    length, secondsShowPref, soundOnPref, src, substring, ticking, value,
    visible, widthPref
*/

var hr, mn, se, dt, mnth, yr,
	hour, mins, secs, date, month, year, am_pm,
	oldSecondsShowPref, oldWidthPref,

	zzzz = WidgetPath + "Resources/zzzz.wav",
        sparks = WidgetPath + "Resources/sparks.wav",
	relay = WidgetPath + "Resources/relay.wav",
	electricDrone = WidgetPath + "Resources/electricDrone.wav",
	shutdown = WidgetPath + "Resources/shutdown.wav",
        tingingSound = WidgetPath + "Resources/ting.wav";
        
var oldleftHourIndicator = null,
	oldrightHourIndicator = null,
	oldleftMinuteIndicator = null,
	oldrightMinuteIndicator = null,
	oldleftSecondIndicator = null,
	oldrightSecondIndicator = null;
	
var windowPos = 0;

//==============================================================
// function called on the widget onload event
//==============================================================
function widgetOnLoad() {
        mainScreen();
        setPrefs();                       // set the preferences - required by Xwidget as it has no native prefs
        resize();                         // resize if required
        setBgImage();
        var scale = Number(preferencesWidthPrefValue.percent) / 100;

        leftHourIndicator.left =  10 ;
        bgimage1.left =  10 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  leftHourIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  leftHourIndicator.src = WidgetPath + "Resources/0G.png";
        }

        rightHourIndicator.left =  239 ;
        bgimage2.left =  239 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  rightHourIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  rightHourIndicator.src = WidgetPath + "Resources/0G.png";
        }

        leftMinuteIndicator.left =  534 ;
        bgimage3.left =  534 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  leftMinuteIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  leftMinuteIndicator.src = WidgetPath + "Resources/0G.png";
        }
        
        rightMinuteIndicator.left = 773 ;
        bgimage4.left =  773 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  rightMinuteIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  rightMinuteIndicator.src = WidgetPath + "Resources/0G.png";
        }

        leftSecondIndicator.left =  1077 ;
        bgimage5.left =  1077 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  leftSecondIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  leftSecondIndicator.src = WidgetPath + "Resources/0G.png";
        }
        
        rightSecondIndicator.left =  1316 ;
        bgimage6.left =  1316 ;
        if (preferencesFontPrefValue.text != "MostraOne") {
		  rightSecondIndicator.src = WidgetPath + "Resources/0.png";
        } else {
		  rightSecondIndicator.src = WidgetPath + "Resources/0G.png";
        }

	oldleftHourIndicator = leftHourIndicator.src,
	oldrightHourIndicator = rightHourIndicator.src,
	oldleftMinuteIndicator = leftMinuteIndicator.src,
	oldrightMinuteIndicator = rightMinuteIndicator.src,
	oldleftSecondIndicator,
	oldrightSecondIndicator;
        
        if (preferencesSecondsShowPrefValue.text != "0") {
        	oldleftSecondIndicator = leftSecondIndicator.src;
        	oldrightSecondIndicator = rightSecondIndicator.src;
        }
        if (preferencesSecondsShowPrefValue.text != "0") {
        	widget.width  = 1500 ;
		leftSecondIndicator.visible = true;
                rightSecondIndicator.visible = true; 
                bgimage5.visible = true;
                bgimage6.visible = true;
        } else {
        	print("invisi");                         
                widget.width  = 800 ;
		leftSecondIndicator.visible = false;
                rightSecondIndicator.visible = false;
                bgimage5.visible = false;
                bgimage6.visible = false;
         }

        //clockTimer.enabled = true;
	oldSecondsShowPref = preferencesSecondsShowPrefValue.text;
	oldWidthPref = preferencesWidthPrefValue.text;
	if (preferencesSoundOnPrefValue.text != "0") {playSound(electricDrone)};

        setmenu();
        
        leftHourIndicator.visible = true;
        bgimage1.visible = true;
        rightHourIndicator.visible = true;
        bgimage2.visible = true;
        leftMinuteIndicator.visible = true;
        bgimage3.visible = true;
        rightMinuteIndicator.visible = true;
        bgimage4.visible = true;
}
//=====================
//End function
//=====================



//==============================================================
// function to return date and time values
//==============================================================
function returndateandtimevalues() {
	if (preferencesHour24PrefValue.text == "0") {
		// adjust hours from 24-hour time to 12 hour time
		if (hr === 0) {
			hr = 12;
			am_pm = 'am';
		} else if (hr < 12) {
			am_pm = 'am';
		} else if (hr === 12) {
			am_pm = 'pm';
		} else if (hr > 12) {
			am_pm = 'pm';
			hr = hr - 12;
		}
	}

	// normalise from variables to strings
	hour = String(hr);
	mins = String(mn);
	secs = String(se);
}
//=====================
//End function
//=====================


//==============================================================
// function to animate and update the nixie tube counters
//==============================================================
function updatecounters() {
	function rattle(o) {
		o.visible = false;
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(relay ) };
                }
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(relay ) };
                }
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(zzzz) };
                }
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(sparks) };
                }
	}

	function rattle2(o) {
		o.visible = false;
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(relay ) };
                }
		sleep(1);
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(relay ) };
                }
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		sleep(5);
		o.visible = false;
		sleep(5);
		o.visible = true;
		//(zzzz);
		if (preferencesTenSecondTickSoundPrefValue.text != "0") {
                  if (preferencesSoundOnPrefValue.text != "0") {PlaySound(sparks ) };
                }
	}

	//determine which number to display on the hour
	if (hour.length < 2) {
		hour = "0" + hour;
	}
        if (preferencesFontPrefValue.text != "LARGE") {
           leftHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(0, 1) + '.png';
        } else {
           leftHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(0, 1) + 'G.png';
        }
        if (oldleftHourIndicator !== leftHourIndicator.src) {
		rattle(leftHourIndicator);
	}
        if (preferencesFontPrefValue.text != "LARGE") {
	   rightHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(1, 2) + '.png';
        } else {
	   rightHourIndicator.src = WidgetPath + 'Resources/' + hour.substring(1, 2) + 'G.png';
        }
       	if (oldrightHourIndicator !== rightHourIndicator.src) {
		rattle(rightHourIndicator);
	}
	oldleftHourIndicator = leftHourIndicator.src;
	oldrightHourIndicator = rightHourIndicator.src;

	//determine which number to display on the minutes
	if (mins.length < 2) {
		mins = "0" + mins;
	}
        if (preferencesFontPrefValue.text != "LARGE") {
           leftMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(0, 1) + '.png';
        } else {
           leftMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(0, 1) + 'G.png';
        }
	if (oldleftMinuteIndicator !== leftMinuteIndicator.src) {
		rattle(leftMinuteIndicator);
	}
        if (preferencesFontPrefValue.text != "LARGE") {
	    rightMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(1, 2) + '.png';
	} else {
	    rightMinuteIndicator.src = WidgetPath + 'Resources/' + mins.substring(1, 2) + 'G.png';
        }
        if (oldrightMinuteIndicator !== rightMinuteIndicator.src) {
		rattle(rightMinuteIndicator);
	}
 
	oldleftMinuteIndicator = leftMinuteIndicator.src;
	oldrightMinuteIndicator = rightMinuteIndicator.src;

	if (preferencesSecondsShowPrefValue.text == "0") {
              return;
        }
        

	//determine which number to display on the seconds
	if (secs.length < 2) {
		secs = "0" + secs;
	}
        if (preferencesFontPrefValue.text != "LARGE") {
           leftSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(0, 1) + '.png';
	} else {
           leftSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(0, 1) + 'G.png';
        }
	if (oldleftSecondIndicator !== leftSecondIndicator.src) {
		rattle2(leftSecondIndicator);
	}
        if (preferencesFontPrefValue.text != "LARGE") {
	   rightSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(1, 2) + '.png';
	} else {
	   rightSecondIndicator.src = WidgetPath + 'Resources/' + secs.substring(1, 2) + 'G.png';
	}
        if (preferencesTickSoundPrefValue.text != "0") { PlaySound(zzzz) };

	oldleftSecondIndicator = leftSecondIndicator.src;
	oldrightSecondIndicator = rightSecondIndicator.src;
}
//=====================
//End function
//=====================


//==============================================================
// function to update the time
//==============================================================
function updateTime() {
	//initialise the time function
	var time = new Date(), timerInterval;

	//returns the date/time in a string format
	hr = time.getHours();
	mn = time.getMinutes();
	se = time.getSeconds();	// 0..59

	if (preferencesSecondsShowPrefValue.text == "0") {
 		timerInterval = 60 - se;	// 1..60 the interval to the next minute mark
		if (timerInterval > 10) { timerInterval -= 5; }
		clockTimer.setInterval = timerInterval;
	}

	returndateandtimevalues();

	//display the letters and numbers of the time
	updatecounters();

}
//=====================
//End function
//=====================



//===========================================
// this function opens other widgets URL
//===========================================
function otherwidgets() {
          if (confirm2("This button opens a browser window and connects to the Steampunk widgets page on my site. Do you wish to proceed?"))
          {
		openURL("http://lightquick.co.uk/steampunk-widgets.html?Itemid=264");
		if (preferencesSoundOnPrefValue.text == "1") {
			PlaySound(winding);
		}
          }	
}
//=====================
//End function
//=====================

//===========================================
// this function opens the URL for paypal
//===========================================
function donate() {
        if (confirm2("Help support the creation of more widgets like this, send us a beer! This button opens a browser window and connects to the Paypal donate page for this widget). Will you be kind and proceed?"))
        {
                openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@lightquick.co.uk&currency_code=GBP&amount=2.50&return=&item_name=Donate%20a%20Beer");
		if (preferencesSoundOnPrefValue.text === "1") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================

//===========================================
// this function opens my Amazon URL wishlist
//===========================================
function amazon() {
        if (confirm2("Help support the creation of more widgets like this. Buy me a small item on my Amazon wishlist! This button opens a browser window and connects to my Amazon wish list page). Will you be kind and proceed?"))
        {
		openURL("http://www.amazon.co.uk/gp/registry/registry.html?ie=UTF8&id=A3OBFB6ZN4F7&type=wishlist");
	}
}
//=====================
//End function
//=====================

//===========================================
// this function opens the rocketdock URL
//===========================================
function rocketdock() {
        if (confirm2("Log in and vote for my widgets on Rocketdock. This button opens a browser window and connects to the Rocketdock page where you can give the widget a 5 star rating... Will you be kind and proceed?"))
	{
		openURL("http://rocketdock.com/addon/icons/46779");
		if (preferencesSoundOnPrefValue.text === "1") {
			PlaySound(winding);
		}
	}
}
//=====================
//End function
//=====================





//===========================================
// this function allows a spacer in the menu
//===========================================
function nullfunction() {
	print("dummy");
}
//=====================
//End function
//=====================


//=========================================================================
// this function closes the preferences
//=========================================================================
function button2OnClick(Sender)
{        if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};
         showWidgetPreferences.visible = false;
         widget.WindowZPosition=windowPos;

}
//=====================
//End function
//=====================



//=========================================================================
// this function shows the preferences when the first menu option is chosen
//=========================================================================
function menuitem8OnClick(Sender)
{         
         windowPos = widget.WindowZPosition;
         showWidgetPreferences.top =  nixiewidget.top + 100;
         showWidgetPreferences.visible = true;
         widget.WindowZPosition=1;
         //widget.forceToFround();
         //widget.bringToFront();
}
//=====================
//End function
//=====================

//=========================================================================
// this function opens the online help file
//=========================================================================
function menuitem1OnClick() {
          if (confirm2("This button opens a browser window and connects to the help page for this widget. Do you wish to proceed?"))
          {
		openURL("http://lightquick.co.uk/instructions-for-the-steampunk-thermionic-nixie-tubes.html?Itemid=264");
          }
}
//=====================
//End function
//=====================

//=========================================================================
// this function opens the browser at the contact URL
//=========================================================================
function menuitem2OnClick() {
        if (confirm2("Visiting the support page - this button opens a browser window and connects to our contact us page where you can send us a support query or just have a chat). Proceed?"))
	{
		openURL("http://lightquick.co.uk/contact.html?Itemid=3");
		if (preferencesSoundOnPrefValue.text == "1") {
			PlaySound(winding);
		}
	}		
}
//=====================
//End function
//=====================

//=========================================================================
// this function reloads the widget - but it doesn't...
//=========================================================================
function menuitem9OnClick() {
         widget.cmd("!Reload");
         alert("You can reload all Xwidgets simply by pressing F5 when the widget is running.");
}
//=====================
//End function
//=====================



//=========================================================================
// this function opens the download URL
//=========================================================================
function update() {
        if (confirm2("Download latest version of the widget (this button opens a browser window and connects to the widget download page where you can check and download the latest zipped .WIDGET file). Proceed?"))
	{
		openURL("http://lightquick.co.uk/downloads/steampunk-thermionic-nixie-tube-widget.html?Itemid=264");
		if (preferencesSoundOnPrefValue.text == "enable") {
			PlaySound(winding);
		}
	}	
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the main context menu
//=========================================================================
function setmenu() {
   //nothing here as this can't be done in javascript with Xwidgets
}
//=====================
//End function
//=====================


//======================================================================================
// Function to move the main_window onto the main screen
//======================================================================================
function mainScreen() {
    // if the widget is off screen then move into the viewable window

    if (widget.left < 0) {
        widget.left = 10;
    }
    if (widget.top < 0) {
        widget.top = 10;
    }
}
//=====================
//End function
//=====================

//======================================================================================
// Function to perform commands
//======================================================================================
function performCommand() {
    print("preferencesImageCmdPrefValue.text "+preferencesImageCmdPrefValue.text);
    if ( preferencesImageCmdPrefValue.text == "" )
    {
        if (confirm2("This widget has not been assigned a double-click function yet - You need to open the preferences and set a function for this widget. Do you wish to proceed?"));
        {
                   showWidgetPreferences();
        }
    }
    if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};
    run(preferencesImageCmdPrefValue.text);
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the preference values to saved values
//=========================================================================
function setPrefs(){
    preferencesWidthPrefValue.percent =     Getinivalue(widgetpath+"prefs.ini","prefs","preferencesWidthPrefValue",100);
    preferencesSoundOnPrefValue.text     = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesSoundOnPrefValue","1");
    preferencesHour24PrefValue.text      = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesHour24PrefValue","1");
    preferencesTenSecondTickSoundPrefValue.text       = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesTenSecondTickSoundPrefValue","1");
    preferencesFontPrefValue.text        = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesFontPrefValue","");
    preferencesSecondsShowPrefValue.text = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesSecondsShowPrefValue","1");
    preferencesTickSoundPrefValue.text   = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesTickSoundPrefValue","1");
    preferencesImageCmdPrefValue.text    = Getinivalue(widgetpath+"prefs.ini","prefs","preferencesImageCmdPrefValue","arseburgers");

    if (preferencesSoundOnPrefValue.text != "0") {
        allSoundsButton.Checked = true;
    } else {
        allSoundsButton.Checked = false;
    }
    
    if (preferencesHour24PrefValue.text != "0") {
        use24ClockButton.Checked = true;
    } else {
        use24ClockButton.Checked = false;
    }    
    
    if (preferencesTenSecondTickSoundPrefValue.text != "0") {
        enableTenSecondSoundsButton.Checked = true;
    } else {
        enableTenSecondSoundsButton.Checked = false;
    }

    if (preferencesSecondsShowPrefValue.text != "0") {
        showSecondsButton.Checked = true;
    } else {
        showSecondsButton.Checked = false;
    }

    if (preferencesTickSoundPrefValue.text != "0") {
        enableTickSoundsButton.Checked = true;
    } else {
        enableTickSoundsButton.Checked = false;
    }
}
//=====================
//End function
//=====================



//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function saveButtonOnClick(Sender)
{
         showWidgetPreferences.visible = false;
         if (preferencesSoundOnPrefValue.text == "1") {PlaySound(electricDrone)};

         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesWidthPrefValue",preferencesWidthPrefValue.percent);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesSoundOnPrefValue",preferencesSoundOnPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesHour24PrefValue",preferencesHour24PrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesTenSecondTickSoundPrefValue",preferencesTenSecondTickSoundPrefValue.percent);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesFontPrefValue",preferencesFontPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesSecondsShowPrefValue",preferencesSecondsShowPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesTickSoundPrefValue",preferencesTickSoundPrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesImageCmdPrefValue",preferencesImageCmdPrefValue.text);

         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.text);
         widget.WindowZPosition=windowPos;
         widgetOnLoad();
}
//=====================
//End function
//=====================


//=========================================================================
// this function opens the about us image
//=========================================================================
function menuitem11OnClick() {
         //print("here!");
         windowPos = widget.WindowZPosition;
         aboutUsImage.visible = true;
         widget.WindowZPosition=1;
}
//=====================
//End function
//=====================

//=========================================================================
// this function closes the about us image
//=========================================================================
function aboutUsImageOnClick() {
         widget.WindowZPosition=windowPos;
         aboutUsImage.visible = false;
}
//=====================
//End function
//=====================

//=========================================================================
// this function selects the Mostra font
//=========================================================================
function mostraButtonOnMouseDown() {
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         preferencesFontPrefValue.text = "LARGE";
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};

         setBgImage();
}
//=====================
//End function
//=====================

//=========================================================================
// this function selects the Arial Narrow font
//=========================================================================
function arialButtonOnMouseDown() {
         print("preferencesFontPrefValue.Text "+ preferencesFontPrefValue.Text);
         preferencesFontPrefValue.Text = "NARROW";
         //preferencesFontPrefValue.font.family = "Arial Narrow";
         print("preferencesFontPrefValue.text "+ preferencesFontPrefValue.Text);
         if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};
         setBgImage();
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for the 24hr clock
//=========================================================================
function setBgImage()
{
         if (preferencesFontPrefValue.text == "LARGE") {
         bgimage1.src = WidgetPath + "Resources/nixiebg1.png";
         bgimage2.src = WidgetPath + "Resources/nixiebg1.png";
         bgimage3.src = WidgetPath + "Resources/nixiebg1.png";
         bgimage4.src = WidgetPath + "Resources/nixiebg1.png";
         bgimage5.src = WidgetPath + "Resources/nixiebg1.png";
         bgimage6.src = WidgetPath + "Resources/nixiebg1.png";
         } else {
         bgimage1.src = WidgetPath + "Resources/nixiebg2.png";
         bgimage2.src = WidgetPath + "Resources/nixiebg2.png";
         bgimage3.src = WidgetPath + "Resources/nixiebg2.png";
         bgimage4.src = WidgetPath + "Resources/nixiebg2.png";
         bgimage5.src = WidgetPath + "Resources/nixiebg2.png";
         bgimage6.src = WidgetPath + "Resources/nixiebg2.png";
         }
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the prefs for the 24hr clock
//=========================================================================
function use24ClockButtonOnMouseDown(Sender)
{
      preferencesHour24PrefValue.text = use24ClockButton.Checked;
      if (use24ClockButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for all the sounds
//=========================================================================
function allSoundsButtonOnMouseDown(Sender)
{
      preferencesSoundOnPrefValue.text = allSoundsButton.Checked;
      if (allSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencesSoundOnPrefValue.text == "1") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for storing the tick sounds ach second
//=========================================================================
function enableTickSoundsButtonOnMouseDown(Sender)
{
      preferencesTickSoundPrefValue.text = enableTickSoundsButton.Checked;
      if (enableTickSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencesSoundOnPrefValue.text === "1") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the prefs for storing the ten second tick sounds
//=========================================================================
function enableTenSecondSoundsButtonOnMouseDown(Sender)
{
      preferencesTenSecondTickSoundPrefValue.text = enableTenSecondSoundsButton.Checked;
      if (enableTenSecondSoundsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencesSoundOnPrefValue.text === "1") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the prefs for howing the seconds tubes
//=========================================================================
function showSecondsButtonOnMouseDown(Sender)
{
        preferencesSecondsShowPrefValue.text = showSecondsButton.Checked;  
        if (preferencesSecondsShowPrefValue.text == "0") {
		leftSecondIndicator.visible = false;
                rightSecondIndicator.visible = false;
                bgimage5.visible = false;
                bgimage6.visible = false;
        } else {
		leftSecondIndicator.visible = true;
                rightSecondIndicator.visible = true;
                bgimage5.visible = true;
                bgimage6.visible = true;
        } 
      if (showSecondsButton.Checked != 0 ) {
               //PlaySound(tingingSound);
               if (preferencesSoundOnPrefValue.text === "1") {PlaySound(tingingSound)};
      }
}
//=====================
//End function
//=====================



//=========================================================================
// this function states the slider size in percentage in the little box on the prefs page
//=========================================================================
function preferencessizePrefvalueOnChange(Sender)
{    if (preferencesSoundOnPrefValue.text == "1") {PlaySound(zzzz)};
     preferencesWidthPrefValue.percent ;
     preferencesWidthPrefValue.hint =     "The widget size will be "  + preferencesWidthPrefValue.percent + "%";
     widgetSize.text =     preferencesWidthPrefValue.percent +"%";
}
//=====================
//End function
//=====================


//==============================================================
// function to resize all images using the volumeDevice single layer
//==============================================================
function resize() {
    //default value = 34
    if (preferencesWidthPrefValue.percent == 0) {preferencesWidthPrefValue.percent=34};
    print ("preferencesWidthPrefValue.percent " + preferencesWidthPrefValue.percent);
    var Scale = Number(preferencesWidthPrefValue.percent+5) / 100;
    nixiewidget.scaleto(Scale,Scale,0.0000000001,"topleft");
}
//=====================
//End function
//=====================

